﻿using System;
using System.Windows;
using System.Diagnostics;
using System.Windows.Controls;

namespace InjectorDemo
{
    /// <summary>
    /// InjectorWindow.xaml 的交互逻辑
    /// </summary>
    public partial class InjectorWindow
    {
        private Process targetProcess;

        public InjectorWindow()
        {
            InitializeComponent();
        }


        private void startUpTargetProcess_Click(object sender, RoutedEventArgs e)
        {
            targetProcess = Process.Start("InjectTargetApp.exe");
            startUpTargetProcess.IsEnabled = false;
            DoInject.IsEnabled = true;
        }

        private void DoInject_Click(object sender, RoutedEventArgs e)
        {
            if (targetProcess != null)
            {
                ManagedInjector.Injector.Launch(targetProcess.MainWindowHandle, typeof(InjectorWindow).Assembly, typeof(InjectorWindow).FullName, "DoSomethingEvie");
            }


        }

        public static void DoSomethingEvie()
        {
            var targetWindow = Application.Current.MainWindow;

            if (targetWindow != null)
            {
                var lb = new Label {Content = "haha, i caught you :)"};
                targetWindow.Content = lb;
            }
        }

        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            try
            {
                targetProcess.Kill();
            }
            catch (Exception)
            {

            }
            base.OnClosing(e);
        }
    }
}
